/* TIGRE Graph reducer  -- SIM.H */
/* (C) Copyright 1989   Philip Koopman Jr.  */
/*  Last update:  4/17/89   */
/*  Test code version -- not for distribution  */

/* header for simulation stuff */

typedef enum Memory_Space {
     rd,   wr,
     rdme, wrme,
     rdp,  wrp,
     rdg,  wrg
    /* me = me ptr, p = parent ptr, g = grand ptr, rd=read, wr=write */
    } Memory_Space ;

/* dinero III constants */
#define DATA_READ          0
#define DATA_WRITE         1
#define INSTRUCTION_FETCH  2
#define UNKNOWN_ACCESS     3
#define CACHE_FLUSH        4

#define nil 0

extern void simulate(Memory_Space space, INT_32 daddr );
extern void Initialize_Instruments();

#if INSTRUMENTS || DUMP_TRACE
#define sim(x,y)  simulate(x, (INT_32) (y) )
#else
#define sim(x,y)  /* nop */
#endif

#define dsim(x,y)  sim(x,y);  sim(x, ((INT_32) (y) + 4 ) ) ;  \
                   count_double ++ ;

/* instrumentation variables */
extern long count_data_read    ; /* data fetches */
extern long count_data_write   ; /* data stores */
extern long count_stackme_read ; /* top of stack reads */
extern long count_stackme_write ; /* top of stack writes */
extern long count_stackp_read  ; /* second on stack reads */
extern long count_stackp_write  ; /* second on stack writes */
extern long count_stackg_read  ; /* third on stack reads */
extern long count_stackg_write  ; /* third on stack writes */
extern long count_double        ; /* places for double word transfers */